"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InterpretationDataRd(ProtocolElement):
    """
    Represents the set of all interpretation data (excluding file
    contents) to be stored in MDT for one TieringResult. Semantic
    restrictions (not automatically verifiable):  * All
    InterpretedGenomes in interpretationResults refer to the
    TieringResult tieringResult. * All InterpretedGenomes in
    interpretationResults have passed the QC stage and have been
    approved by the originating GMCs
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "interpretationMetaData",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import reports as reports_6_9_0

        return {
            "interpretationMetaData": reports_6_9_0.InterpretationRequestRD,
            "otherInterpretationResults": reports_6_9_0.InterpretedGenome,
            "tieringResult": reports_6_9_0.InterpretedGenome,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import reports as reports_6_9_0

        return {
            "org.gel.models.report.avro.InterpretationRequestRD": reports_6_9_0.InterpretationRequestRD,
            "org.gel.models.report.avro.InterpretedGenome": reports_6_9_0.InterpretedGenome,
            "org.gel.models.report.avro.InterpretedGenome": reports_6_9_0.InterpretedGenome,
            "org.gel.models.report.avro.InterpretationDataRd": reports_6_9_0.InterpretationDataRd,
        }

    __slots__ = [
        "interpretationMetaData",
        "otherInterpretationResults",
        "tieringResult",
    ]

    def __init__(
        self,
        interpretationMetaData,
        otherInterpretationResults=None,
        tieringResult=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_9_0.InterpretationDataRd model.

        :param interpretationMetaData:
        :type interpretationMetaData: InterpretationRequestRD
        :param otherInterpretationResults:
        :type otherInterpretationResults: None | list[InterpretedGenome]
        :param tieringResult:
        :type tieringResult: None | InterpretedGenome
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.9.0"
